﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using System.Windows.Data;

namespace UnboundColumnBinding
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            Elements = new ObservableCollection<Element>()
            {
                new Element { UserName = "User 1", Points = "point1; point2" },
                new Element { UserName = "User 2", Points = "point3; point4" },
                new Element { UserName = "User 3", Points = "point5; point6" },
            };
            DataContext = this;
        }

        public ObservableCollection<Element> Elements { get; set; }
    }

    public class UnboundElementConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string[] pts = value.ToString().Split(new char[] { ';' });
            string newValue = "Points with numbers: ";

            foreach (string item in pts)
            {
                newValue += item.Last() + " ";
            }

            return newValue;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


    public class Element : INotifyPropertyChanged
    {

        private string uName;

        public string UserName
        {
            get { return uName; }
            set { uName = value; OnPropertyChanged("UserName"); }
        }

        private string points;

        public string Points
        {
            get { return points; }
            set { points = value; OnPropertyChanged("Points"); }
        }
        

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

}
